export type DeepPartial<T> = T extends Function ? T : T extends object ? {
    [P in keyof T]?: DeepPartial<T[P]>;
} : T;
export type NonMutable<T extends object> = {
    [Key in keyof Omit<T, 'mutate'>]: T[Key] extends object ? NonMutable<ObjectOnly<T>> | Exclude<T[Key], ObjectOnly<T>> : T[Key];
};
export type ObjectOnly<T> = T extends object ? (T extends Array<infer U> ? never : T extends CallableFunction ? never : T) : never;
export type Mutable<T extends object = any, K = any> = {
    [Key in keyof T]: Key extends 'mutate' ? T[Key] : T[Key] extends object ? Mutable<ObjectOnly<T[Key]>, K> : T[Key];
} & {
    mutate?: {
        [key: string]: DeepPartial<Mutated<T, K>> | ((this: K, obj: T, conditions: MutableCondition[], ...args: any) => any);
    };
};
export type Mutated<T extends object, K = any> = {
    [Key in keyof T]: T[Key] extends object ? Mutated<Exclude<T[Key], CallableFunction>> | Extract<T[Key], CallableFunction> : T[Key] | symbol;
} | symbol;
export type MutableCondition = string | {
    condition: string;
    args?: () => any | any[];
};
export declare const deleteValue: unique symbol;
export declare function deepAssign(currentObj: Record<any, any>, newObj: Record<any, any>): Record<any, any>;
export declare function applyMutation<T extends object>(conditions: MutableCondition[], obj: T, option?: {
    keepMutation?: boolean;
    top?: boolean;
}): any;
